; x86life: a life simulating game
; Copyright (C) 2023-2024 luca0N!
; 
; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, version 3 of the License.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <https://www.gnu.org/licenses/>.
;
; <https://git.luca0n.com/luca0N/x86life>
; Contact: <https://www.luca0n.com/en/contact>

.read:
    ; read digit stdin
    XOR RAX, RAX
    XOR RDI, RDI
    SYSCALL

    ; remove line feed, if present
    DEC RAX
    ADD RSI, RAX
    CMP [RSI], BYTE 0x0A
    JNE .read_ret
    MOV [RSI], BYTE 0x00
.read_ret:
    SUB RSI, RAX
    RET

; vim: syntax=nasm ts=4 sw=4 et
