; x86life: a life simulating game
; Copyright (C) 2023-2024 luca0N!
; 
; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, version 3 of the License.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <https://www.gnu.org/licenses/>.
;
; <https://git.luca0n.com/luca0N/x86life>
; Contact: <https://www.luca0n.com/en/contact>

;SECTION .rodata
;    num equ 20
;SECTION .data
;    buf times 3 db 20h
;SECTION .text
;    GLOBAL _start
.getHumanReadableNum:
;    MOV AL, num         ; put num on RAX
    PUSH RAX            ; save num on stack
    MOV BL, 100         ; check for hundredth digit
    DIV BL              ; divide RAX by BL
    CMP AL, 0

;    MOV RSI, buf
    ADD AL, 0x30        ; digit to ASCII
    MOV [RSI], AL

    SUB AL, 0x30
    MUL BL              ; multiply AL by BL
    MOV BL, AL
    POP RAX             ; get original saved number
    SUB AL, BL          ; discard hundreds

    PUSH RAX
    MOV BL, 10
    DIV BL              ; get tenth digit

    INC RSI             ; next buffer byte
    ADD AL, 0x30        ; digit to ASCII
    MOV [RSI], AL

    SUB AL, 0x30
    MUL BL
    MOV BL, AL
    POP RAX
    SUB AL, BL

    INC RSI
    ADD AL, 0x30
    MOV [RSI], AL

    SUB RSI, 2
    RET

; vim: syntax=nasm ts=4 sw=4 et
